/* This program is part of Crank, a cryptanalysis tool
 * Copyright (C) 2000 Matthew Russell
 *
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License (LICENSE) for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

/* FILE: 
 * main.c
 *
 * FUNCTION: 
 * location of main()
 */

#include "crank.h"
#include "error.h"
#include "register_componant.h"
#include "componant.h"
#include "instance.h"
#include "plugin.h"
#include "gui_support.h"
#include "gui_interface.h"
#include "gui_init.h"
#include "globals.h"


int main(int argc, char *argv[]) {
    int comp_index;
    componant *componant_list;
    int number_of_componants;
    init_globals();
    
    number_of_componants = register_componants(&componant_list);
    set_componant_list(componant_list);
    set_number_of_componants(number_of_componants);
    //init_gui(argc, argv, componant_list + 1, componant_list + 2, componant_list + 3, componant_list + 0);
    init_gui(argc, argv, componant_list + 8, componant_list + 5, componant_list + 7, componant_list + 4);
       
    /* Keep memprof happy */
    for (comp_index = 0; comp_index < number_of_componants; comp_index++) {
	if (componant_list[comp_index].type == COMPONANT_TYPE_TRANSFORM) 
	    free(componant_list[comp_index].type_data.transform);
	if (componant_list[comp_index].type == COMPONANT_TYPE_FITNESS) 
	    free(componant_list[comp_index].type_data.fitness);
	if (componant_list[comp_index].type == COMPONANT_TYPE_HEURISTIC) 
	    free(componant_list[comp_index].type_data.heuristic);
	if (componant_list[comp_index].module)
	    module_close(componant_list[comp_index].module);
	
    }
    free(componant_list);
    return 0;

}
